    node {
        
            stage('Initialize') {
                /* Let's make sure we have the repository cloned to our workspace */
                checkout scm
                step([$class: 'DockerBuilderPublisher', cleanImages: false, cleanupWithJenkinsJobDelete: false, cloud: 'docker', dockerFileDirectory: '', fromRegistry: [], pushCredentialsId: 'id_dockerhub', pushOnSuccess: true, tagsString: 'msmarwen/test'])
                {
                    
                }
                

            }

            stage('Build image') {
            
                def dockerHome = tool 'docker'
                env.PATH = "${dockerHome}/bin:${env.PATH}"
                sh "docker ps" 
                /* app = docker.build("getting-started") */
            }

            stage('Test image') {
                /* Ideally, we would run a test framework against our image.
                * For this example, we're using a Volkswagen-type approach ;-) */

                app.inside {
                    sh 'echo "Tests passed"'
                }
            }

            stage('Push image') {
                /* Finally, we'll push the image with two tags:
                * First, the incremental build number from Jenkins
                * Second, the 'latest' tag.
                * Pushing multiple tags is cheap, as all the layers are reused. */
                docker.withRegistry('https://registry.hub.docker.com', 'id_dockerhub') {
                    app.push("${env.BUILD_NUMBER}")
                    app.push("latest")
                }
            }
            
            
            stage ('Build and Test') {
            echo 'Downloading Repository and Running build and Junit Tests'
            git branch: 'master', url: 'https://gitlab.com/ms.marwen/projet_formation'
            def mvnHome = tool name: 'maven' , type: 'maven'
            sh "/var/jenkins_home/tools/hudson.tasks.Maven_MavenInstallation/Maven_3.6.0/bin/mvn package -Dmaven.test.skip=true"
            
            }
            stage('Code Quality analyse SonarQube') {
            echo 'Running SonarQube Scanner'
            def mvnHome = tool name: 'maven' , type: 'maven'
            sh "/var/jenkins_home/tools/hudson.tasks.Maven_MavenInstallation/Maven_3.6.0/bin/mvn sonar:sonar -Dsonar.host.url=http://5.252.178.179:9000 -Dsonar.login=2b61eb47a1d3f83c959ee42428ec3e01ca2e83f1"
                }
            
            

            stage("SSH Deploy Test Server") {
                    echo 'deploy JAR file to Test Server'
                sh '''sudo kill -9 `sudo lsof -t -i:8081`'''
        sshPublisher(publishers: [sshPublisherDesc(configName: 'Marwen_Server', transfers: [sshTransfer(cleanRemote: false, excludes: '', execCommand: 'java -jar /jenkins_deploy/target/Projet_formation-0.0.1-SNAPSHOT.jar', execTimeout: 120000, flatten: false, makeEmptyDirs: false, noDefaultExcludes: false, patternSeparator: '[, ]+', remoteDirectory: '', remoteDirectorySDF: false, removePrefix: '', sourceFiles: '**/target/Projet_formation-0.0.1-SNAPSHOT.jar')], usePromotionTimestamp: false, useWorkspaceInPromotion: false, verbose: false)])
            }

            stage ('PostMan test') {
                            echo 'Running PostMan Tests'

            }
        }

